(**
  To be viewed in Isabelle/jedit IDE. In a normal text editor, this will just be UNREADABLE!

  http://isabelle.in.tum.de

*)
theory Sepref_Demo
imports Refine_Imperative_HOL.IICF
begin


interpretation Refine_Monadic_Syntax .

abbreviation "heap_assn \<equiv> heap_rel" (* Hide legacy name! *)

(* TODO: Move! *)
context bind_map begin
  lemma assn_intf_of[intf_of_assn]: "intf_of_assn K TYPE('k) \<Longrightarrow> intf_of_assn V TYPE('v) 
    \<Longrightarrow> intf_of_assn (assn K V) TYPE(('k,'v)i_map)" by simp

end

declare PROTECT2_def[autoref_tag_defs]



definition abstract :: \<open>int multiset \<Rightarrow> (int\<rightharpoonup>bool) \<Rightarrow> (int\<rightharpoonup>bool) nres\<close> where  
  \<open>abstract Q m \<equiv> do {
    assert (Q\<noteq>{#});
    v \<leftarrow> spec v. v\<in>#Q \<and> (\<forall>x\<in>#Q. v\<le>x);
        
    case m v of
      None \<Rightarrow> return (m(v\<mapsto>True))
    | Some _ \<Rightarrow> return m
  }\<close>

lemma manual_refine_get_min: \<open>(assert (Q\<noteq>{#}) \<then> (spec v. v\<in>#Q \<and> (\<forall>x\<in>#Q. v\<le>x)) \<bind> f ) = assert (Q\<noteq>{#}) \<then> mop_prio_peek_min id Q \<bind> f\<close>
  unfolding mop_prio_peek_min_def
  by (auto simp: refine_pw_simps pw_eq_iff)
    
sepref_definition concrete is "uncurry abstract" 
  :: \<open>(heap_assn id int_assn)\<^sup>k *\<^sub>a (hm.assn int_assn bool_assn)\<^sup>d \<rightarrow>\<^sub>a hm.assn int_assn bool_assn\<close>
  unfolding abstract_def
  apply (rewrite manual_refine_get_min)
  by sepref

 
export_code concrete checking SML_imp  
    
(* In more detail: *)    
sepref_definition concrete' is "uncurry abstract" 
  :: \<open>(heap_assn id int_assn)\<^sup>k *\<^sub>a (hm.assn int_assn bool_assn)\<^sup>d \<rightarrow>\<^sub>a hm.assn int_assn bool_assn\<close>
  unfolding abstract_def
  apply (rewrite manual_refine_get_min)
  
  apply sepref_dbg_preproc
  apply sepref_dbg_cons_init
  apply sepref_dbg_id
  apply sepref_dbg_monadify
  
  (*unfolding autoref_tag_defs (* To make goal more readable *)*)
  
  apply sepref_dbg_opt_init
  
  (* Translation phase *)
  apply sepref_dbg_trans_step  (* assert *)
  apply sepref_dbg_trans_step
  apply sepref_dbg_trans_step  (* peek min *)
  apply sepref_dbg_trans_step
  apply sepref_dbg_trans_step  (* lookup *)
  apply sepref_dbg_trans_step  (* case \<dots> of (split) *)
  apply sepref_dbg_trans_step    (* Initial frame*)
  apply sepref_dbg_trans_step    (* None branch*)
  apply sepref_dbg_trans_step      (* True*)
  apply sepref_dbg_trans_step      (* Map update *)
  apply sepref_dbg_trans_step      (* aux-var for True goes out of scope *)
  apply sepref_dbg_trans_step      (* Case-variable goes out of scope (skipped in slides)*)
  apply sepref_dbg_trans_step    (*Some branch*)
  apply sepref_dbg_trans_step      (* Variables go out of scope *)
  apply sepref_dbg_trans_step      (* Merge *)
  apply sepref_dbg_trans_step      (* aux-var for lookup-result goes out of scope *)
  apply sepref_dbg_trans_step      (* v goes out of scope*)
  
  
  apply sepref_dbg_opt          (* Post-process synthesized program *) 
  apply sepref_dbg_cons_solve   (* Match post-state specified in sepref_definition command *)
  apply sepref_dbg_cons_solve   (* Match specified result-relation *)
  apply sepref_dbg_constraints  (* Solve forward-constraints, if any (Not explained in slides) *)
  done

end
