(**
  To be viewed in Isabelle/jedit IDE. In a normal text editor, this will just be UNREADABLE!

  http://isabelle.in.tum.de

*)
theory Simple_Invar_Demo
imports "Refine_Imperative_HOL.IICF"
begin
  interpretation Refine_Monadic_Syntax .  

  definition \<open>sum_up S \<equiv> do {
    (a,_) \<leftarrow> while\<^sub>T (\<lambda>(a,S). S\<noteq>{}) (\<lambda>(a,S). do {
      x \<leftarrow> spec x. x\<in>S;
      return (a+x, S-{x})
    }) (0,S);
    return a
  }\<close>

  lemma \<open>finite S\<^sub>0 \<Longrightarrow> sum_up S\<^sub>0 \<le> (spec r. r=\<Sum>S\<^sub>0)\<close>
    unfolding sum_up_def
    (* Generate VCs *)
    apply (refine_vcg WHILET_rule[where 
          I="\<lambda>(a,S). a = \<Sum>(S\<^sub>0-S) \<and> S\<subseteq>S\<^sub>0" 
      and R = "measure (\<lambda>(a,S). card S)" ])
    (* Solve VCs \<dots> Here: Used auto and sledgehammer *)  
    apply (auto)
    subgoal
      by (simp add: ab_semigroup_add_class.add.commute it_step_insert_iff)
    subgoal 
      by (meson card_Diff1_less infinite_super) 
    done


  (* Generation of VCs in detail *)  
  lemma \<open>finite S\<^sub>0 \<Longrightarrow> sum_up S\<^sub>0 \<le> (spec r. r=\<Sum>S\<^sub>0)\<close>
    unfolding sum_up_def
    apply (rule Refine_Basic.bind_rule)
    apply (rule WHILET_rule[where 
          I="\<lambda>(a,S). a = \<Sum>(S\<^sub>0-S) \<and> S\<subseteq>S\<^sub>0" 
      and R = "measure (\<lambda>(a,S). card S)" ])
    defer
    defer
    apply (rule prod_rule)  
    apply (rule Refine_Basic.bind_rule)
    apply (rule SPEC_rule)
    apply (rule RETURN_rule)
    defer
    apply (rule prod_rule)  
    apply (rule RETURN_rule)
    defer
    oops

    
    
  definition \<open>is_42in S \<equiv> do {
    (f,_) \<leftarrow> while\<^sub>T (\<lambda>(f,S). S\<noteq>{} \<and> \<not>f) (\<lambda>(f,S). do {
      x \<leftarrow> spec x. x\<in>S;
      return (x=42, S-{x})
    }) (False,S);
    return f
  }\<close>
    
  lemma "finite S\<^sub>0 \<Longrightarrow> is_42in S\<^sub>0 \<le> (spec r. r\<longleftrightarrow>42\<in>S\<^sub>0)"  
    unfolding is_42in_def
    apply (refine_vcg WHILET_rule[where I="\<lambda>(f,S). S\<subseteq>S\<^sub>0 \<and> f=(42\<in>S\<^sub>0-S)" and 
      R="inv_image finite_psubset snd"]
      )
    by (auto intro: finite_subset) 
    
    
  definition euclid :: "nat \<Rightarrow> nat \<Rightarrow> nat nres" where "euclid a b \<equiv> do {
    (a,b)\<leftarrow>while\<^sub>T (\<lambda>(a,b). a\<noteq>b) (\<lambda>(a,b). 
      if a<b then return (a,b-a) else return (a-b,b)
    ) (a,b);
    return a
  }"

  lemma "\<lbrakk> a\<^sub>0>0; b\<^sub>0>0\<rbrakk> \<Longrightarrow> euclid a\<^sub>0 b\<^sub>0 \<le> (spec x. x=gcd a\<^sub>0 b\<^sub>0)"  
    unfolding euclid_def
    apply (refine_vcg WHILET_rule[where 
      I="\<lambda>(a,b). gcd a b = gcd a\<^sub>0 b\<^sub>0 \<and> a>0 \<and> b>0" and 
      R="measure (\<lambda>(a,b). a+b)"
      ])
    (** Show how to find proof interactively! *)  
    apply (auto)
    subgoal 
      by (metis gcd.commute gcd_diff1_nat less_or_eq_imp_le)
    subgoal 
      by (simp add: gcd_diff1_nat)
    done
      
    
        
end
